#if FOR_CASIO
void point (unsigned int x, unsigned int y, unsigned int segm) {
//	;input values:
//	;ES = video memory segment (normal page 0 is 1A20h)
//	;	add 40h for each page after
//	;bit 0 of AL = value to write
//	;CX = desired ROW!!!
//	;DX = desired COLUMN!!!
//	;push ax
//	;push cx
//	;push dx
  asm {
        mov al,1
        mov cx,x
        mov dx,y
        mov es,segm
	mov si,0x003f
	sub si,dx
	sub cx,0x80
	not cx
	push cx
	and cl,0xf8
	shl cx,0x03
	add si,cx
	pop cx
	and cl,0x07
	mov ah,0xfe
	rol ah,cl
	and [es:si],ah
	mov ah,al
	rol ah,cl
	or [es:si],ah
    }
  }
#else
  void point (unsigned int x, unsigned int y, unsigned int segm) {
    pokeb (segm,XEKR*y+x,10);
  }
#endif

void line (int x1,int y1,int x2,int y2, unsigned int segm)
{
    int xd, yd;
    int x, y;
    int ax, ay;
    int sx, sy;
    int dx, dy;

    dx = x2 - x1;
    dy = y2 - y1;

    ax = ABS(dx) << 1;
    ay = ABS(dy) << 1;

    sx = ZSGN(dx);
    sy = ZSGN(dy);

    x = x1;
    y = y1;

    if (ax >= ay)            /* x dominant */
    {
        yd = ay - (ax >> 1);
        for (;;)
        {
            point (x, y, segm);
            if (x == x2)
                return;
            if (yd >= 0) {
                y += sy;
                yd -= ax;
            }
            x += sx;
            yd += ay;
        }
    }
    else /* y dominant */
    {
        xd = ax - (ay >> 1);
        for (;;)
        {
            point (x, y, segm);
            if (y == y2) return;
            if (xd >= 0) {
                x += sx;
                xd -= ay;
            }
            y += sy;
            xd += ax;
        }
    }
}